#include <stdio.h>
#include <signal.h>
#include <stdlib.h>
#include <unistd.h>

static void handler_usr1(int); /* begin call*/
static void handler_usr2(int); /* end call */

static void bye(const char* string) 
{
    printf("ERROR: %s\n", string);
    exit(1);
}

int ongoing = 0;
int finished = 0;

int main(int argc, char **argv) 
{
    int interval;
    
    printf("My pid is %d\n", getpid());
    /* parse args */
    if (argc != 2) {
	bye("Wrong command line arguments");
    }
    interval = atoi(argv[1]);
    if (interval == 0) {
	bye("Invalid interval");
    }
    
    /* install handlers */
    if (signal(SIGUSR1, handler_usr1) == SIG_ERR) {
	bye("error while registering handler_usr1");
    }
    if (signal(SIGUSR2, handler_usr2) == SIG_ERR) {
	bye("error while registering handler_usr1");
    }
    /* display info periodically */
    while (1) {
	printf("Ongoing: %d Finished: %d\n", ongoing, finished);
	sleep(interval);
    }
}

static void handler_usr1(int signo) 
{
    int i, j;
    if (signo == SIGUSR1) {
	ongoing++; /* begin call */
	for (j=0; j < 10000; j++) {
	    for (i=0; i < 500000; i++);
	    printf("ongoing: %d\n", ongoing);
	}
    } 
    else {
	bye("Should be SIGUSR1 ...");
    }
}

static void handler_usr2(int signo) 
{
    if (signo == SIGUSR2) {
	finished++; /* end call */
	ongoing--;
    } 
    else {
	bye("Should be SIGUSR2 ...");
    }
}
